var bLeftOpen = false;
var iLeftPart = 1;
var bRightOpen = false;
var iRightPart = 1;
var timerEvent = "";
var bVideoVisible = false;


function init() {
	if (theme.loadPreference('Repeat') == 'True') {
		player.settings.setMode('loop',down);		
	}
	
	effects.currentEffectType = mediacenter.effectType;
	effects.currentPreset = mediacenter.effectPreset;  

	// Initial movement //
	head.top = 40;		//head initial position
	left_part1.left = 21;	//left_part initial position  (move from position)
	right_part1.left = 550;	//right_part initial position (move from position)
	head.moveto(0,0,500);
	timerEvent = "init";
	noodle.timerInterval = 250;
	showArm = 1;
}

function changeText (text) {
	var state = player.playState;
	var author = player.currentMedia.getItemInfo ("author");
	var title = player.currentMedia.name;

	var info_text;
	if (title == ""){
		info_text = "";
	} else {
		if (author != "") {
			info_text = author + "́w" + title + "xłB\n"
		} else {
			info_text = title + "łB\n";
		}
	}

	switch (state) {
		case 0:
			text.value = "";
			return;
		case 1:
			text.value = "";
			return;
		case 2:
			if (player.controls.isAvailable ("Pause")) {
				text.value = info_text;
			} else {
				text.value = info_text + "ꎞ~B";
			}
			return;
		case 3:
			text.value = info_text;
			return;
		case 4:
			text.value = info_text + "蒆B";
			return;
		case 5:
			text.value = info_text + "߂B";
			return;
		case 6:
			text.value = info_text + "obt@OłB";
			return;
		case 7:
			text.value = info_text + "҂B";
			return;
		case 8:
			text.value = "";
		case 9:
			text.value = info_text + "҂B";
			return;
		case 10:
			text.value = info_text;
			return;
	}
}

function savePreferences() {
	theme.savePreference('LeftOpen', bLeftOpen);
	theme.savePreference('RightOpen', bRightOpen); 
	theme.savePreference('VideoVisible', bVideoVisible);
	theme.savePreference('Repeat', player.settings.getMode('loop'));
	mediacenter.effectType = effects.currentEffectType;
	mediacenter.effectPreset = effects.currentPreset;
}

function leftPartControls() {
	if (player.settings.getMode('loop')) {
		repeat.down = true;
	}
	
	// Frame 1 //
	openleft.tabStop = !bLeftOpen;
	
	// Frame 11 //
	ejectclose.tabStop = bLeftOpen;
	screen.tabStop = bLeftOpen;
	playlist.tabStop = bLeftOpen;
	closeleft.tabStop = bLeftOpen;
	vis.tabStop = bLeftOpen;
	pl.tabStop = bLeftOpen;
	repeat.tabStop = bLeftOpen;
	playback_slider.tabStop = bLeftOpen;
}

function rightPartControls() {
	// Frame 1 //
	openright1.tabStop = !bRightOpen;
//	vol1.tabStop = !bRightOpen;
	
	// Frame 7 //
	leds.visible = bRightOpen;
	
//	vol7.tabStop = bRightOpen;
	openright7 = bRightOpen;
	closeright = bRightOpen;
	eq_controls = bRightOpen;
	eq1.tabStop = bRightOpen;
	eq2.tabStop = bRightOpen;
	eq3.tabStop = bRightOpen;
	eq4.tabStop = bRightOpen;
	eq5.tabStop = bRightOpen;
	eq6.tabStop = bRightOpen;
	eq7.tabStop = bRightOpen;
	eq8.tabStop = bRightOpen;
	eq9.tabStop = bRightOpen;
	eq10.tabStop = bRightOpen;
}

function startTimer(event) {
	noodle.timerInterval = 150;	//Right + Left AnimationIntervalTime
	timerEvent = event;
}

function stopTimer() {
	noodle.timerInterval = 0;
	timerEvent = "";
}

function timerHandler() {

	if (timerEvent == "init") {
		left_part1.moveto(21,93,400);
		right_part1.moveto(550,110,400);
		
		stopTimer();
		leftPartControls();
		rightPartControls();
		playStateChange();
	}
	if (timerEvent == "left") {
		if (iLeftPart == 11) {
			playlist.visible = screen.visible = video.visible = effects.visible = false;
		}
	
		showAnim = "left_part" + iLeftPart;
		eval(showAnim).visible = false;
		
		if (!bLeftOpen) {
			iLeftPart = iLeftPart + 1;
		} else {
			iLeftPart = iLeftPart - 1;
		}
		
		showAnim = "left_part" + iLeftPart;
		eval(showAnim).visible = true;
		
		if ((iLeftPart == 11)||(iLeftPart == 1)) {
			stopTimer();
			bLeftOpen = !bLeftOpen;
	
			if 	(bLeftOpen) { 
				showLeft(); 
			}
			leftPartControls();
		}
	}
	if (timerEvent == "right") {
		if (iRightPart == 7) {
			leds.visible = false;
		}
	
		showAnim = "right_part" + iRightPart;
		eval(showAnim).visible = false;
		
		if (!bRightOpen) { iRightPart = iRightPart + 1; }
		else { iRightPart = iRightPart - 1; }
		
		showAnim = "right_part" + iRightPart;
		eval(showAnim).visible = true;
		
		if ((iRightPart == 7)||(iRightPart == 1)) {
			stopTimer();
			bRightOpen = !bRightOpen;
			rightPartControls();
		}
	}


	showArm = showArm * (-1);
	if( showArm > 0 ) {
		arm00.visible = false;
		arm01.visible = true;
		arm02.visible = false;
	} else {
		arm00.visible = false;
		arm01.visible = false;
		arm02.visible = true;

	}

}


function openStateChange() {
	if((player.OpenState == osMediaOpen) && bLeftOpen)
	{
		screen.visible = true;
		video.visible = (player.currentMedia.ImageSourceWidth>0);
		effects.visible = !video.visible;
	}
}

function playStateChange() {	
	if ((player.playState==3)||(player.playState==6)||(player.playState==7)||(player.playState==9)) {  // playing, buffering, waiting, connecting
		if ((player.currentMedia.ImageSourceWidth>0) && (!bLeftOpen)) {
			bVideoVisible = true;
			startTimer('left');
		}
		if ((player.currentMedia.ImageSourceWidth>0) && (!bVideoVisible)) {
			showVideo();
		}
	}

	// Display status //
	if (player.playState==3) {	//playing
		media_name.value = player.currentMedia.name;
		media_name.scrolling = true;
	} else {
		media_name.value = player.status;
		media_name.scrolling = false;
	}	
}

function showLeft() {
	if (bVideoVisible) {
		showVideo();
	} else {
		showPlaylist();
	}
}

function showPlaylist() {
	screen.visible = video.visible = effects.visible = false;
	playlist.visible = true;
	vis.visible = true;
	pl.visible = false;
	
	bVideoVisible = false;
}

function showVideo() {
	playlist.visible = false;
	pl.visible = true;
	vis.visible = false;
	
	if (!bLeftOpen) {
		playlist.visible = screen.visible = video.visible = effects.visible = false;	// just in case...
		startTimer('left');
	} else {
		screen.visible = true;
		video.visible = (player.currentMedia.ImageSourceWidth>0);
		effects.visible = !video.visible;	
	}
	
	bVideoVisible = true;
}

function showVisuals() {
	playlist.visible = false;
	pl.visible = true;
	vis.visible = false;
	
	if (bLeftOpen) {
		screen.visible = true;
		video.visible = (player.currentMedia.ImageSourceWidth>0);
		effects.visible = !video.visible;
	} else {
		playlist.visible = screen.visible = video.visible = effects.visible = false;
	}
	
	bVideoVisible = true;
}
